
#if ! defined colorizeApp_h
#define colorizeApp_h


#include "GDApplication.h"
#include "ColourFloatWin.h"
#include "ToolsFloatWin.h"
#include "ShadesFloatWin.h"
#include "TexturesWin.h"
#include "ColoringTool.h"
#include "GDFile.h"


class ColorizeDocWin;
class TDocument;


class
	ColorizeApp :
public
	gd::GDApplication
{
public:
	ColorizeApp();
	void InitializeFloatingWindows();

	void GetLicenseKeyFromPreferences();

	enum menuValues {
		MENU_FILE_NEW = 40001,
		MENU_APPLICATION_ABOUT_COLORIZE,
		MENU_FILE_OPEN,
		MENU_FILE_CLOSE,
		MENU_FILE_SAVE,
		MENU_FILE_SAVEAS,
		MENU_FILE_SCAN,
		MENU_FILE_SELECT_SCANNER,
		MENU_FILE_EXPORT_EPS,
		MENU_FILE_EXPORT_TIFF,
		MENU_FILE_EXPORT_SCITEX_LW,
		MENU_FILE_PREFERENCES,
		MENU_FILE_EXIT,
		MENU_EDIT_UNDO,
		MENU_EDIT_CUT,
		MENU_EDIT_COPY,
		MENU_EDIT_PASTE,
		MENU_EDIT_DELETE,
		MENU_EDIT_SELECT_ALL,
		MENU_EDIT_DESELECT,
		MENU_IMAGE_INVERT_SHADE,
		MENU_IMAGE_HIDE_SHADE,
		MENU_IMAGE_SHOW_ALL_SHADES,
		MENU_IMAGE_IMPORT_SHADES,
		MENU_IMAGE_DELETE_SHADE,
		MENU_IMAGE_RESOLUTION,
		MENU_IMAGE_INFORMATION,
		MENU_IMAGE_MOVELAYERUP,
		MENU_IMAGE_MOVELAYERDOWN,
		MENU_IMAGE_DOCUMENTINKS,
		MENU_IMAGE_ZOOM_IN,
		MENU_IMAGE_ZOOM_OUT,
		MENU_IMAGE_FIT_TO_SCREEN,
		MENU_IMAGE_CALIBRATE_SCREEN,
		MENU_IMAGE_PRINT_PREVIEW_ONLY,
		MENU_FILE_ROUND_BRUSH,
		MENU_FILE_SQUARE_BRUSH,
		MENU_TOOLS_BRUSH_SIZE,
		MENU_TOOLS_LINE_WIDTH,
		MENU_TOOLS_OUTLINE_WIDTH,
		MENU_TOOLS_SEED_SIZE,
		MENU_TOOLS_DESPECKLE_SENSITIVITY,
		MENU_TOOLS_TRAPPING,
		MENU_TOOLS_TRANSFER_TRAPPING,
		MENU_TOOLS_HIDE_TOOLBOX,
		MENU_TOOLS_HIDE_SHADES,
		MENU_TOOLS_HIDE_COLOR,
		MENU_TOOLS_HIDE_COLOR_FAMILIES,
		MENU_TOOLS_HIDE_POSITION,
		MENU_TOOLS_HIDE_RULERS,
		MENU_TOOLS_SET_F5,
		MENU_TOOLS_SET_F6,
		MENU_TOOLS_SET_F7,
		MENU_TOOLS_SET_F8,
		MENU_TOOLS_SET_F9,
		MENU_TOOLS_SET_F10,
		MENU_TOOLS_SET_F11,
		MENU_TOOLS_SET_F12,
		MENU_TOOLS_SET_F13,
		MENU_TOOLS_SET_F14,
		MENU_TOOLS_SET_F15,
		MENU_TOOLS_ERASE_OVERLAP,
		MENU_TOOLS_TURBO_DRAW,
		MENU_TOOLS_TEST_EDIT_TEXTURES,
		MENU_TOOLS_EDIT_INK_LIBRARIES,
		MENU_TOOLS_TEST_1
	};
	void AdjustMenus() {
	}
/*
	static ColorizeApp* Instance()
	{
		static ColorizeApp* instance = 0;
		if ( instance == 0 )
			instance = new ColorizeApp();
		return instance;
	}
*/
private:
	//TDocument*				m_CurrentDocument;
	//ColorizeDocWin*			m_CurrentDocumentWindow;
	ColourFloatWin				m_ColourFloatWin;
	ToolsFloatWin				m_ToolsFloatWin;
	ShadesFloatWin				m_ShadesFloatWin;
	TexturesFloatWin			m_TexturesFloatWin;
	ColoringToolHolder			m_ColoringTool;
	long						applicationFileID;
	
	long						brushShape;
public:
	std::vector< InkLibrary >   inkLibraries;
	bool						licenseKeyIsValid;

	long NumInkLibraries();
	InkLibrary* GetInkLibrary( long index );

	void DoBrushSizeDialog();

	void SetSquareBrush();
	void SetRoundBrush();
	long BrushShape();

	TDocument* CurrentDocument();
	void SetCurrentDocument( TDocument* doc )
	{
		//m_CurrentDocument = doc;
	}
	ColorizeDocWin* CurrentDocumentWindow();
	void SetCurrentDocumentWindow( ColorizeDocWin* docWin );
	ColourFloatWin* ColorsFloatWin()
	{
		return &m_ColourFloatWin;
	}
	ShadesFloatWin* ShadesWin()
	{
		return &m_ShadesFloatWin;
	}
	void DocumentChanged();
	void ColourFloatWindowTextBoxChanged();
	void ColorWindowChanged();
	void ShadesWindowChanged();
	void SetLayerInkValue100AndRefresh( long documentId, long layerId, long inkIndex, long inkValue100, long startOrEndColor );

	ColoringToolHolder& Tool()
	{
		return m_ColoringTool;
	}
	void BuildMenuTree();
	void OpenFormat2003( const gd::FileIdentifier& openFile );
	void OpenFormat2004( const gd::FileIdentifier& openFile );
	void OpenFormat_Colorize_Legacy( const gd::FileIdentifier& openFile, long version );
	void SpeedTest();
	void XORBlendMover();
	void DocumentHasClosed();
	void CheckLicenseKey( const std::wstring& licenseKey );
	void AskForLicenseKey();
	void DisplayDemonstrationModeMessage();
	
	virtual void	CloseAllFiles();
	virtual bool	AllFilesClosed();
};


#endif

